#pragma	once

//O[oϐ̐錾
double	a;//̌W
double	t_start,t_finish;
double	x_start;
double	v_start;
double	d_t;//ï߻
FILE	*fxdata;
int	algorithm;
Vector	(*algo[3])(Vector	X);

//֐̐錾`

//l
Vector	euler_dX(Vector	X){
	return	Vector(	X[1],	-a*X[1]*(X[0]*X[0]-1)-X[0]);
}

Vector	Runge_dX(Vector	X){
	Vector	K1,K2,K3,K4;
	Vector	Temp;
	
	K1	=	euler_dX(	X);
	Temp	=		K1;
	Temp	*=	(d_t/2);
	Temp	+=	X;
	K2	=	euler_dX(	Temp);
	K2	*=	2;
	Temp	=		K2;
	Temp	*=	(d_t/2);
	Temp	+=	X;
	K3	=	euler_dX(	Temp);
	K3	*=	2;
	Temp	=		K3;
	Temp	*=	d_t;
	Temp	+=	X;
	K4	=	euler_dX(	Temp);
	Temp	=		K1;
	Temp	+=		K2;
	Temp	+=		K3;
	Temp	+=		K4;
	
	return	(	Temp	)	/6	;
}

Vector	G(	Vector	Xi1,	Vector	Xi){
	Vector	Temp;
	Temp	=		euler_dX(	Xi1);
	Temp	*=	-d_t;
	Temp	-=	Xi;
	Temp	+=	Xi1;
	return	Temp;
}
Vector2	DG_inverse(	Vector	X){
	Vector	Temp1,Temp2;
	Vector2	Temp;
	Temp1	=	Vector(	1+a*d_t*(	X[0]*X[0]	-	1	),	d_t);
	Temp2	=	Vector(	2*a*d_t*X[0]*X[1]+d_t,	1);
	Temp	=	Vector2(	Temp1,	Temp2);
	Temp	/=	((1+a*d_t*(	X[0]*X[0]	-	1	))	-	(2*a*d_t*X[0]*X[1]+d_t)*d_t);
	return	Temp;
}
Vector	ieuler_dX(	Vector	X){
	Vector	Temp,	Temp1;
	Vector2	Temp2;
	Temp	=	X;
	while(	Abs(	G(	Temp,	X))	>	0.000001	){
		Temp1	=		G(	Temp,	X);
		Temp2	=		DG_inverse(Temp);
		Temp1	=		Temp2	*	Temp1;
		Temp	-=	Temp1;
	}
	Temp	-=	X;
	return	Temp;
}

//ϕ
void	integral(){
	Vector	X(	x_start,	v_start);
	Vector	temp;
	printf(	"t		");
	printf(	"l	");
	printf(	"l	");
	printf(	"\n");

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"l	");
	fprintf(	fxdata,	"l	");
	fprintf(	fxdata,	"\n");

	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){

		printf(	"%f	",	t);
		printf(	"%f	",	X[0]);
		printf(	"%f	",	X[1]);
		printf(	"\n");

		fprintf(	fxdata,	"%f	",	t);
		fprintf(	fxdata,	"%f	",	X[0]);
		fprintf(	fxdata,	"%f	",	X[1]);
		fprintf(	fxdata,	"\n");

		temp	=	algo[algorithm-1](X);
		temp	*=	d_t;
		X	+=	temp;
		
	}
}

void	integral_all(){

	Vector	X[3];
	for(	int	i=0;	i	<	3;	i++){
		X[i]	=	Vector(	x_start,	v_start);
	};

	Vector	temp;

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"IC[@		");
	fprintf(	fxdata,	"ÓTIQNb^@		");
	fprintf(	fxdata,	"ރIC[@");
	fprintf(	fxdata,	"\n");

	fprintf(	fxdata,	"	");
	for(	int	i=0;	i<3;	i++){
		fprintf(	fxdata,	"	");
		fprintf(	fxdata,	"	");
	}
	fprintf(	fxdata,	"\n");

	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){
		printf(	"%f	",	t);
		fprintf(	fxdata,	"%f	",	t);
		for(	int	i=0;	i	<	3;	i++){
			printf(	"%f	",	X[i][0]);
			printf(	"%f	",	X[i][1]);
			fprintf(	fxdata,	"%f	",	X[i][0]);
			fprintf(	fxdata,	"%f	",	X[i][1]);
			temp	=	algo[i](X[i]);
			temp	*=	d_t;
			X[i]	+=	temp;
		}
		printf(	"\n");
		fprintf(	fxdata,	"\n");
	}		
}


//ϕ@̑I
void	select_algorithm(){
	//ϐ錾
	algorithm	=	0;
	char	temp[256];	
	//ϕ@I
	while(	(algorithm	<	1)	|	(4	<	algorithm)	){
		printf("ϕ@IĂB\n");
		printf("@@1FIC[@\n");
		printf("@@2FÓTIQNb^@\n");
		printf("@@3FރIC[@\n");
		printf("@@4FׂĂ̕@ōs\n");
		printf("ԁHF");
		gets(	temp	);
		algorithm	=	atoi(	temp);
		switch(	algorithm	){
			case	1:
				fprintf(	fxdata,	"IC[@\n");
				break;
			case	2:
				fprintf(	fxdata,	"ÓTIQNb^@\n");
				break;
			case	3:
				fprintf(	fxdata,	"ރIC[@\n");
				break;
			case	4:
				fprintf(	fxdata,	"ׂĂ̕@\n");
			break;
		}
	}
}

//ϕ̐ݒ
void	establishment(){
	//ϐ錾
	char	temp[256];
	
	//ϐ̓		
	cout	<<	"̌W\n";
	fprintf(	fxdata,	"W\n");

	cout	<<	"  a : ";
	cin	>>	a;
	fprintf(	fxdata,	"a	%f\n",	a);

	cout	<<	"l\n";
	fprintf(	fxdata,	"l\n");
	
	cout	<<	"  t : ";
	cin	>>	t_start;
	fprintf(	fxdata,	"t	%f\n",	t_start);
	
	cout	<<	"  x : ";
	cin	>>	x_start;
	fprintf(	fxdata,	"x	%f\n",	x_start);

	cout	<<	"  v : ";
	cin	>>	v_start;
	fprintf(	fxdata,	"v	%f\n",	v_start);
		
	cout	<<	"Il\n";
	fprintf(	fxdata,	"Il\n");
	
	cout	<<	"  t : ";
	cin	>>	t_finish;
	fprintf(	fxdata,	"t	%f\n",	t_finish);
	
	cout	<<	"XebvTCY\n";
	fprintf(	fxdata,	"XebvTCY\n");
	
	cout	<<	"  h : ";
	cin	>>	d_t;
	fprintf(	fxdata,	"h	%f\n",	d_t);
}